using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.IO;
using System.Xml;

namespace TypingManiaUtility
{
    public partial class Form2 : Form
    {
        public Form2()
        {
            InitializeComponent();
        }

        private void Form2_FormClosing(object sender, FormClosingEventArgs e)
        {
            //̂ł͂ȂB
            this.Hide();
            e.Cancel = true;
        }

        private void button1_Click(object sender, EventArgs e)
        {
            OpenFileDialog ofd = new OpenFileDialog();
            ofd.Filter = "musiclist.xml|musiclist.xml|ׂẴt@C(*.*)|*.*";
            if (ofd.ShowDialog() == DialogResult.OK)
            {
                XmlReaderSettings xrs = new XmlReaderSettings();
                xrs.CloseInput = true;
                xrs.ConformanceLevel = ConformanceLevel.Document;
                xrs.IgnoreWhitespace = true;
                xrs.IgnoreComments = true;
                XmlReader xr = XmlReader.Create(ofd.OpenFile(), xrs);
                try
                {
                    string InvalidDataMessage = "XMĽ`܂B";
                    xr.Read();
                    if (xr.NodeType != XmlNodeType.XmlDeclaration) throw new InvalidDataException(InvalidDataMessage);
                    xr.Read();
                    if (xr.NodeType != XmlNodeType.Element || xr.Name != "musicinformation") throw new InvalidDataException(InvalidDataMessage);
                    xr.Read();
                    dataGridView1.Rows.Clear();
                    while (!xr.EOF && !(xr.NodeType == XmlNodeType.EndElement && xr.Name == "musicinformation"))
                    {
                        if (xr.NodeType != XmlNodeType.Element || xr.Name != "musicinfo") throw new InvalidDataException(InvalidDataMessage);
                        dataGridView1.Rows.Add("", "", "", "", "", null);
                        dataGridView1["xmlpath", dataGridView1.Rows.Count - 2].Value = xr.GetAttribute("xmlpath");
                        dataGridView1["musicpath", dataGridView1.Rows.Count - 2].Value = xr.GetAttribute("musicpath");
                        xr.Read();
                        while (!xr.EOF && !(xr.NodeType == XmlNodeType.EndElement && xr.Name == "musicinfo"))
                        {
                            if (xr.NodeType != XmlNodeType.Element) throw new InvalidDataException(InvalidDataMessage);
                            switch (xr.Name)
                            {
                                case "musicname":
                                case "artist":
                                case "genre":
                                case "level":
                                    string name = xr.Name;
                                    xr.Read();
                                    if (xr.NodeType == XmlNodeType.Text) dataGridView1[name, dataGridView1.Rows.Count - 2].Value = xr.Value;
                                    if (xr.NodeType == XmlNodeType.Element) break;
                                    xr.Read();
                                    if (xr.NodeType != XmlNodeType.EndElement) throw new InvalidDataException(InvalidDataMessage);
                                    break;
                                default:
                                    xr.Read();
                                    if (xr.NodeType == XmlNodeType.Element) break;
                                    xr.Read();
                                    if (xr.NodeType != XmlNodeType.EndElement) throw new InvalidDataException(InvalidDataMessage);
                                    break;
                            }
                            if (xr.NodeType != XmlNodeType.Element) xr.Read();
                        }
                        if (xr.NodeType != XmlNodeType.Element) xr.Read();
                    }
                }
                catch (InvalidDataException ex)
                {
                    MessageBox.Show(ex.Message, this.Text, MessageBoxButtons.OK, MessageBoxIcon.Error);
                }
                finally
                {
                    xr.Close();
                }
            }
        }

        private void button2_Click(object sender, EventArgs e)
        {
            SaveFileDialog sfd = new SaveFileDialog();
            sfd.Filter = "musiclist.xml|musiclist.xml|ׂẴt@C(*.*)|*.*";
            if (sfd.ShowDialog() == DialogResult.OK)
            {
                XmlWriterSettings xws = new XmlWriterSettings();
                xws.Encoding = Encoding.UTF8;
                xws.Indent = true;
                xws.IndentChars = ("\t");
                xws.CloseOutput = true;
                xws.ConformanceLevel = ConformanceLevel.Document;
                XmlWriter xw = XmlWriter.Create(sfd.OpenFile(), xws);

                xw.WriteStartDocument(true);
                xw.WriteStartElement("musicinformation");
                foreach (DataGridViewRow r in dataGridView1.Rows)
                {
                    if (!r.IsNewRow)
                    {
                        xw.WriteStartElement("musicinfo");
                        xw.WriteAttributeString("id", r.Index.ToString());
                        xw.WriteAttributeString("xmlpath", (string)r.Cells["xmlpath"].Value);
                        xw.WriteAttributeString("musicpath", (string)r.Cells["musicpath"].Value);
                        xw.WriteElementString("musicname", (string)r.Cells["musicname"].Value);
                        xw.WriteElementString("artist", (string)r.Cells["artist"].Value);
                        xw.WriteElementString("genre", (string)r.Cells["genre"].Value);
                        xw.WriteElementString("level", (string)r.Cells["level"].Value);
                        xw.WriteEndElement();
                    }
                }
                xw.WriteEndElement();
                xw.Close();
                MessageBox.Show("܂", this.Text, MessageBoxButtons.OK, MessageBoxIcon.Information);
            }
        }

        private void dataGridView1_CellEnter(object sender, DataGridViewCellEventArgs e)
        {
            DataGridView dgv = (DataGridView)sender;
            if (dgv.Columns[e.ColumnIndex] is DataGridViewComboBoxColumn)
                SendKeys.Send("{F4}");
        }

        private void contextMenuStrip1_Opening(object sender, CancelEventArgs e)
        {
            if (dataGridView1.SelectedRows.Count == 0)
            {
                e.Cancel = true;
                return;
            }
            if (dataGridView1.SelectedRows.Count == 1)
                contextMenuStrip1.Items[1].Enabled = true;
            else
                contextMenuStrip1.Items[1].Enabled = false;
            if (dataGridView1.SelectedRows[dataGridView1.SelectedRows.Count - 1].IsNewRow)
            {
                contextMenuStrip1.Items[0].Enabled = false;
                ToolStripMenuItem.Enabled = false;
            }
            else
            {
                contextMenuStrip1.Items[0].Enabled = true;
                ToolStripMenuItem.Enabled = true;
            }
        }

        private void s̍폜ToolStripMenuItem_Click(object sender, EventArgs e)
        {
            foreach (DataGridViewRow r in dataGridView1.SelectedRows)
                if (!r.IsNewRow)
                    dataGridView1.Rows.Remove(r);
        }

        private void ToolStripMenuItem_Click(object sender, EventArgs e)
        {
            dataGridView1.Rows.Insert(dataGridView1.SelectedRows[0].Index, 1);
        }

        private void ToolStripMenuItem_Click(object sender, EventArgs e)
        {
            dataGridView1.Rows.Insert(dataGridView1.SelectedRows[0].Index + 1, 1);
        }
    }
}